       integer NMAX,NMAX2,NT
       real*4 speed,null
       parameter (NMAX=1000000)  
       parameter (NMAX2=5000)      
       parameter (NT=8)                !-number of telluric regions to be masked
       parameter (speed=299792.458)    !-light speed  
       parameter (null=0.0)   


       integer status,r,size,lenf,lenf0,m
       integer i,j,k,ichr,checker,dobs2,nmed,nbn,h
       integer fout,nimax,nlb,nout,sc
       integer linei,nhe,chst,lst,ch,zero,plot,verbose,restart
       integer ik,access,sm_d,ve_d,pie0,conter,it
     
       character spec*100,spec2*100,out1*100,spec0*100,spec3*100
       character spec4*100,out0*100
       character dmp*18,dmp1*13,dmp2*8
       character blabla*52,out2*100,blabla2*47
       character comm*80,endf*80,nps2*10,nps3*10,nps4*10
       character resid*100,cont*100,outps*100,outps2*100
       character exte1*44,exte2*31,exte3*17,outp2*80
       character labx*20,mat3*40,mat4*5
       character list*100,st*200,nline_c*5,res_c*6,st2*10
       character mylab1*30,mylab2*30,xelem*2,elemx(99)*2,xion*3
       character linec*200,outsp*100,superst*100,string1*50,string2*50
       character mylab3*30,wout*1,jcar*1,mask*1,nexe*30,fmask*50,clean*1
       character gala*1,stc*100,mask0*1
       
       real*4 fwhm,ord,w1,w2,fwhm0,fwhm_best
       real*4 vrad,disp,fw2,ex
       real*4 wobs,w,ew,erew,q,w0
       real*4 code(NMAX),gf,ep,g1,g2,g3,bark,res,code0,res_0
       real*4 v1,v2,tol,v10,v20,v1_best,v2_best
       real*4 linex(NMAX),linex1,linex2,pixel,linex0
       real*4 mini,maxi,maxi2,l0,arr1,arr2,pos1,pos2
       real*4 mat1(3,NMAX),wtmp(NMAX),itmp(NMAX),val1,val2,val3
       real*4 itmp2(NMAX),tmp0(NMAX)
       real*4 s_vrad(NMAX),vr1,vr2,vmini,vmaxi,s_wave(NMAX)
       real*4 s_ew(NMAX),wmini,wmaxi,ewmini,ewmaxi
       real*4 s_q(NMAX),s_per(NMAX),wsampl(NMAX),contin(NMAX)
       real*4 w1_orig,w2_orig,e0,q0,ermax,qmax
       real*4 wave_xre,wave_xre0,xre,winp,ewinp,x,nsigma
       real*4 re_fin1(NMAX),re_fin2(NMAX),re_min,re,s_elem(NMAX)
       real*4 m_fin1, s_fin1, m_fin2, s_fin2, elem0,old_f(NMAX)
       real*4 ew0,rv0,val,fmax,stuff
       real*4 wzero(NMAX),masked(NMAX),mask1(NMAX),mask2(NMAX),difx
       real*4 mysave(NMAX2,4)
       real*4 mysave1(NMAX2),mysave2(NMAX2)
       real*4 mysave3(NMAX2),mysave4(NMAX2)
       real*4 med,sig,pie(10),pie_wav(NMAX),pie_sig(NMAX),myres(NMAX)
       real*4 xval,yval,y_1(NMAX),pie2(100),resm
       real*4 d1min,d1max,d2min,d2max,dmin,dmax,difw1
       real*4 a_mysave1(NMAX2),a_mysave2(NMAX2),a_mysave3(NMAX2)
       real*4 b_mysave1(NMAX2),b_mysave2(NMAX2),b_mysave4(NMAX2)
       
       
       integer nline,nl,flag,fx,flag2,flag3,flag4,nl2,flag5,flag6,flag7
       integer fixed,niter,conv,dnoz,ij,j1,j2,io,tell,re_met,idum
       integer nmask,fixed0,re_met0,nc,inl,nl0,jnl,knl
       
       !--- observed spectrum
       real*8 crval,cdelt,naxis,crpix   
       real*8 wox(NMAX) 
       real*4 iox(NMAX),wox2(NMAX) 
       real*4 iox_0(NMAX),wox_0(NMAX) 
       integer dobs
       
       !--- residual
       real*8 crval_r,cdelt_r,naxis_r,crpix_r    
       real*4 i_res(NMAX),i_res_0(NMAX)
       integer dobsr
       
       !--- continuum
       real*8 crval_c,cdelt_c,naxis_c,crpix_c
       real*4 i_cont(NMAX),i_cont_0(NMAX)
       integer dobsc    
       
       
       real*8 crval1,crpix1,cdelt1,dcflag
       real*8 array(NMAX)
       
       real*4 w_obs(NMAX),norma(NMAX),wfitted(NMAX)
       real*4 norma_up(NMAX),norma_low(NMAX)
       real*4 fitted(NMAX)
       real*4 md_s,sg_s
       real*4 telluric(2,NT)
       
       real*4 xgdev
       real*4 xvet(5),yvet(5)

       
       logical anynull,simple,extend
       
       

      data elemx/
     &           'H ','He','Li','Be','B ','C ','N ','O ','F ',
     &  	 'Ne','Na','Mg','Al','Si','P ','S ','Cl','Ar',
     &  	 'K ','Ca','Sc','Ti','V ','Cr','Mn','Fe','Co',
     &  	 'Ni','Cu','Zn','Ga','Ge','As','Se','Br','Kr',
     &  	 'Rb','Sr','Y ','Zr','Nb','Mo','Tc','Ru','Rh',
     &  	 'Pd','Ag','Cd','In','Sn','Sb','Te','I ','Xe',
     &  	 'Cs','Ba','La','Ce','Pr','Nd','Pm','Sm','Eu',
     &  	 'Gd','Tb','Dy','Ho','Er','Tm','Yb','Lu','Hf',
     &  	 'Ta','W ','Re','Os','Ir','Pt','Au','Hg','Tl',
     &  	 'Pb','Bi','Po','At','Rn','Fr','Ra','Ac','Th',
     &  	 'Pa','U ','Np','Pu','Am','Cm','Bk','Cf','Es'/	

       
       
       data telluric/
     &    5889,  5890.5, ! Na D first comp.  
     &    5895,  5896.5, ! Na D second comp.
     &    6275,  6320,   ! O2 X0-b2  
     &    6860,  6930,   ! B Band
     &    7160,  7330,   ! H2O Bands  
     &    7590,  7700,   ! A Band
     &    8125,  8340,   ! H2O Bands
     &    9100,  9800/   ! H2O Bands
         
     
     
       common /dao1/spec,spec2,outp2,spec0,fmask
       
       common /dao2/w1,w2,lenf,wox2,iox,dobs,dobsr,dobsc,fitted,norma,
     &             contin,dobs2,wsampl,wfitted,out2,nl2,fw2,pixel,vrad,
     &             maxi,mat1,fout,wobs,vr1,vr2,disp,
     &             s_vrad,s_wave,s_ew,s_q,s_per,w1_orig,w2_orig,s_elem,
     &             wox,i_res,i_cont,res,mask1,mask2,nmask,nc,myres,resm,
     &             re_met,niter,wave_xre,re,ord,mysave,
     &             mysave1,mysave2,mysave3,mysave4,inl
     
       common /dao3/tol,nimax,fmax,plot,verbose,restart,wout,
     &        mask,clean,gala,conter
       
       common /dao4/crval,cdelt,naxis,crpix,
     &              crval_r,cdelt_r,naxis_r,crpix_r,
     &              crval_c,cdelt_c,naxis_c,crpix_c
       
       
       common /dao5/wox_0,iox_0,i_cont_0,i_res_0,res_0,lenf0
